#include "Compress.h"

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH: break;
   }
   return TRUE;
}

CCompress::CCompress(void)
{
	m_nCompressionRatio = 0;
	input_data		= NULL;
	input_length	= 0;
	output_data		= NULL;
	output_length	= 0;
}

CCompress::~CCompress(void)
{
	m_nCompressionRatio = 0;
	input_data		= NULL;
	input_length	= 0;
	if (output_data	!= NULL && output_length > 0) {
		free(output_data);
		output_length = 0;
	}
}

bool CCompress::setparam(char * key, char * value)
{
	if (strcmp(key, "CompressionRatio") == 0) {
		m_nCompressionRatio = atoi(value);
	}
	else return false;
	return true;
}

bool CCompress::start()
{
	if (output_data == NULL && output_length > 0) free(output_data);
	output_length	= sizeof(int);
	output_data		= malloc(output_length);
	*((int *)output_data) = int (*((int *)input_data) * ((100.0-double(m_nCompressionRatio)) / 100));
	return true;
}

bool CCompress::stop()
{
	return true;
}

CCompress * GetThisComponent(void)
{
	return new CCompress();
}