// DCTestAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DCTestApp.h"
#include "DCTestAppDlg.h"
#include "..\..\Source\DCFormat.h"
#include "..\..\Source\AwareMetaObject.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDCTestAppDlg dialog

int gnReceiveEventApp = RegisterWindowMessageA(szChangeEvent);
int gnActionDoneEventApp= RegisterWindowMessageA(szActionDoneEvent);



CDCTestAppDlg::CDCTestAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDCTestAppDlg::IDD, pParent)
	, m_strEditOutput(_T(""))
	, m_nEditInput(0)
	, m_nEditOutput(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	pdcEngine = NULL;
}

void CDCTestAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_OUTPUT, m_ctlEditOutput);
	DDX_Text(pDX, IDC_EDIT_OUTPUT, m_strEditOutput);
	DDX_Control(pDX, IDC_BTN_PROCESS, m_ctlBtnProc);
	DDX_Text(pDX, IDC_EDIT_INPUT, m_nEditInput);
	DDV_MinMaxInt(pDX, m_nEditInput, 0, 10000);
	DDX_Text(pDX, IDC_EDIT_ACTOUTPUT, m_nEditOutput);
	DDX_Control(pDX, IDC_EDIT_ACTOUTPUT, m_ctlEditActOutput);
}

BEGIN_MESSAGE_MAP(CDCTestAppDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_START, &CDCTestAppDlg::OnBnClickedBtnStart)
	ON_BN_CLICKED(IDC_BTN_STOP, &CDCTestAppDlg::OnBnClickedBtnStop)
	ON_BN_CLICKED(IDC_BTN_CLEAR, &CDCTestAppDlg::OnBnClickedBtnClear)
	ON_WM_DESTROY()
	ON_REGISTERED_MESSAGE(gnReceiveEventApp, OnReceiveAction)
	ON_REGISTERED_MESSAGE(gnActionDoneEventApp, OnActionDoneAction)
	ON_BN_CLICKED(IDC_BTN_PROCESS, &CDCTestAppDlg::OnBnClickedBtnProcess)
END_MESSAGE_MAP()


// CDCTestAppDlg message handlers

BOOL CDCTestAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_ctlBtnProc.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDCTestAppDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDCTestAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CDCTestAppDlg::OnBnClickedBtnStart()
{
	// TODO: Add your control notification handler code here
	// create a new decision engine instance
	pdcEngine = new CDCEngine();//"dc.xml";
	// set the xml file directory
//	pdcEngine->SetXMLFile("dc.xml");
	// set the response application instance
	pdcEngine->SetHWnd(this);
	// start the decision engine
	pdcEngine->Start();
	m_ctlBtnProc.EnableWindow(TRUE);
}

void CDCTestAppDlg::OnBnClickedBtnStop()
{
	// TODO: Add your control notification handler code here
	if (pdcEngine != NULL) {
		// stop the decision engine
		pdcEngine->Stop();
		// release the memory
		delete pdcEngine;
		pdcEngine = NULL;
		m_ctlBtnProc.EnableWindow(FALSE);
	}
}

void CDCTestAppDlg::OnBnClickedBtnClear()
{
	// TODO: Add your control notification handler code here
	m_strEditOutput = _T("");
	UpdateData(FALSE);
}

void CDCTestAppDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	OnBnClickedBtnStop();
}

LRESULT CDCTestAppDlg::OnReceiveAction(WPARAM wParam, LPARAM lParam)
{	
	// when the formatted data is ready, we can get it by GetFormatValue();
	m_strEditOutput += pdcEngine->GetFormatValue();
	m_strEditOutput += "\r\n";
	UpdateData(FALSE);
	return 0;
}

LRESULT CDCTestAppDlg::OnActionDoneAction(WPARAM wParam, LPARAM lParam)
{
	// If the reconfigurable components processing time is long,
	// we can use a seperate thread to process the data and wait
	// for this message when the data has been processed. 
	return TRUE;
}


void CDCTestAppDlg::OnBnClickedBtnProcess()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int input_data = m_nEditInput;
	// input the data, and data size
	pdcEngine->SetMetaObjectInput(&input_data, sizeof(input_data));
	// start to process the data
	pdcEngine->StartMetaObject();
	void *output_data;
	// get the output data, and processed data size
	pdcEngine->GetMetaObjectOutput(&output_data, NULL);
	m_nEditOutput = *(int*)output_data;
	UpdateData(FALSE);
}
