/*********************************************************
Actuator
Actuator is the action of the application when one rule 
is sufficed and notified by the compositional event.
There is one actuator in each rule, corresponding to one
compositional event. 
When the rule is sufficed, the corresponding actuator will
update the architecture (metaobject)
*********************************************************/
#pragma once

#define THREAD_TERMINATION_MAXWAIT	3


#include "Component.h"

class CAwareActuator
{
public:
	CAwareActuator(void);
	CAwareActuator(char chTag);
public:
	virtual ~CAwareActuator(void);

public:
	enum THREADSTATUS {CLOSED=0, CLOSING, RUNNING};
	void Start();
	void Stop();
	void AddCompt(ACTCOMPNT);
	HANDLE getWaitingEvent();

	static DWORD WINAPI ThreadEventWaiting(LPVOID arg);
	void EventWaitingFun();
	void StartThread();
	void StopThread();

protected:
	HANDLE	m_hEvent;	//wait for event to notify this event
	HANDLE	m_threadEventWaiting;	//in this thread, it waits for event notification
	THREADSTATUS	m_statusEventWaiting;	// the waiting thread status

	ACTCOMPNTArray	m_pcompnArray;

	char	m_strEventTag[36];
};

typedef CAwareActuator * CAwareActuatorPtr;
typedef CArray<CAwareActuatorPtr, CAwareActuatorPtr&> CActuatorPtrArray;