/*********************************************************
AwareEvent
This is a virtual class that is the parent of SimpleEvent
and CompositionalEvent.
AwareEvent includes event source, event conditioner, and 
event listener, event source provides the data (from the 
awareness tool or from the lower layer event) to conditioner,
and the conditioner notify the listener if the condition
is sufficed. Upper compositional event or acutual would 
registers itself to the event as listener.
AwareEvent itself is also a subclass of EventSource, because
it is a eventsource of the upper layer compositional event.
*********************************************************/
#pragma once

#include "EventSource.h"
#include "EventConditioner.h"
#include "EventListener.h"

class CAwareEvent :
	public CEventSource
{
public:
	CAwareEvent(void);
public:
	virtual ~CAwareEvent(void);

public:
	virtual void SetSource(SOURCETYPE type, CEventSource * pSrc) {return;}
	virtual void SetConditioner(CEventConditioner * pCond) {return;}
	virtual void SetListener(HANDLE pEvent) {return;}

//inherited from source
public:
	virtual void Start() {return;}
	virtual void Stop()	 {return;}

	bool GetValue(char *value, int *len);
	void SetNotifier(HANDLE hNotifier);
protected:
	CEventConditioner * m_pCondt;
	CEventListener * m_pListener;
};

typedef CAwareEvent * CAwareEventPtr;
typedef CArray<CAwareEventPtr, CAwareEventPtr&> CEventPtrArray;