/***********************************************************
CAwareMetaObject
This class is the architecture of the configured components.
Because there is only one architecture, it is a global variable.
It gets the components data from acutuator that is notified by
the compositional event.
To form the architecture, first, all the parameters of each 
component in the acutuator must be reset because the components 
are also global variables and only has one copy of each component
Currently, there is no synchronization part in this architecture.
************************************************************/

#pragma once

#include "Component.h"
#include <afxmt.h>

static const char * szActionDoneEvent = "ActionHasBeenDone";

class __declspec( dllexport ) CAwareMetaObject
{
public:
	CAwareMetaObject(void);
public:
	~CAwareMetaObject(void);

public:
	virtual void OnReceive();
	void * GetCurrentAction();
	void SetCurrentAction(void *);
	void SetCompnArray(ACTCOMPNTArray * pArray);
	void Start();

	static void SetHWnd(CWnd *pWnd);
	static void SetInput(void *, size_t len);
	static void GetOutput(void ** data, size_t * len);
	static CCriticalSection m_dataLock;

private:
	void * m_pCurrentAction;
	CCompnPtrArray	m_pcompnArray;
};

extern CAwareMetaObject * metaObject;
