/*********************************************************
AwareSource
This is a kind of event source, so that it is inherited from
CEventSource. The data of awaresource is from awareness tool
instead of awareevent.
*********************************************************/
#pragma once

#include "eventsource.h"
#include "aware.h"

#ifndef  DYNAMCI_AWARE_FROM_DLL
#define APPLICATIONAWARE	"Awareness.ApplicationAware"
#define AVAILABLEBANDWIDTH	"Awareness.NetworkAware.AvailableBW"
#define	AVAILABLECPU		"Awareness.DeviceAware.AvailableCPU"
#include "appaware.h"
#include "availablebw.h"
#include "availablecpu.h"
#endif

class CAwareSource :
	public CEventSource
{
public:
	CAwareSource(void);
public:
	virtual ~CAwareSource(void);

public:
	CAwareSource::CAwareSource(CAwareSource &aware);
	CAwareSource& CAwareSource::operator =(CAwareSource &aware);
	bool CAwareSource::operator ==(CAwareSource &aware);
	bool CAwareSource::operator !=(CAwareSource &aware);


public:
	char * GetName();
	void SetName(char * name);
	void SetType(char * type);
	void SetSource(char *source);
	void SetParam(char *name, char *value);

	virtual bool GetValue(char *, int *);
	virtual void SetNotifier(HANDLE hNotifier);
	virtual void Start();
	virtual void Stop();

protected:
	char s_name[256];

protected:
	// aware tool notify the conditioner directly. instead of source notify the conditioner
	// just like conditioner notify the upper layer conditioner, instead of event.
	CAware * m_pDataGenerator;
};

typedef CAwareSource * CAwareSrcPtr;
typedef CArray<CAwareSrcPtr, CAwareSrcPtr&> CAwareSrcPtrArray;