/*********************************************************
Boolean Conditioner
This is a kind of conditioner that compares "AND" or "OR"
operations, so that it is inherited from event conditioner. 
There are two sources of boolean conditioner, called left 
source and right source. 
the event sources of boolean conditioner must be awareevent,
instead of awaresource. 
*********************************************************/
#pragma once
#include "EventConditioner.h"
#include "AwareEvent.h"

class CBooleanConditioner :
	public CEventConditioner
{
public:
	CBooleanConditioner(void);
	CBooleanConditioner(char chTag);
public:
	~CBooleanConditioner(void);

public:
	virtual void Start();
	virtual void Stop();
	virtual void SetType(CONDTYPE type);
	virtual HANDLE GetCondtEvent(CEventSource::SOURCETYPE type);
	virtual void SetEventSource(CEventSource::SOURCETYPE type, CEventSource * pSrc);
	virtual bool GetCondtResult(bool bFormat = false);

public:
	static DWORD WINAPI ThreadSrcWaiting(LPVOID arg);
	void SrcWaitingFun();
	void StartThread();
	void StopThread();

	bool getSourceData(CEventSource::SOURCETYPE side);

protected:
	HANDLE m_hSourceEvent[2];	//wait for sources to notify this event, left and right
	HANDLE m_threadSourceWaiting;	//in this thread, it waits for event notification
	THREADSTATUS m_statusSourceWaiting;	// the waiting thread status
	CONDTYPE m_condType;	// AND, OR
	CAwareEvent * m_pLeftSource;	//the event sources to get the updated data from it
	CAwareEvent * m_pRightSource;

	char m_strLEventTag[36], m_strREventTag[36];
};

typedef CBooleanConditioner * CBooleanConditionerPtr;