/*********************************************************
Compare Conditioner
This is a kind of conditioner that compares "BIGGER","SMALLER",
"BETWEEN", or "BESIDES" operations, so that it is inherited 
from event conditioner. 
There is only one event source of compare conditioner.
the event sources of boolean conditioner must be awaresource,
instead of awareevent. so that the data is directly from
awareness measurement tools
*********************************************************/

#pragma once
#include "EventConditioner.h"
#include "AwareSource.h"

class CCompareConditioner :
	public CEventConditioner
{
public:
	CCompareConditioner(void);
	CCompareConditioner(char chTag);
public:
	~CCompareConditioner(void);

public:
	virtual void SetType(CONDTYPE type);
	virtual HANDLE GetCondtEvent(CEventSource::SOURCETYPE type);
	virtual void SetEventSource(CEventSource::SOURCETYPE type, CEventSource * pSrc);
	virtual bool GetCondtResult(bool bFormat = false);

	virtual void Start();
	virtual void Stop();

public:
	void SetLowerBound(double lb);
	void SetUpperBound(double ub);

	static DWORD WINAPI ThreadSrcWaiting(LPVOID arg);
	void SrcWaitingFun();
	void StartThread();
	void StopThread();

protected:
	HANDLE m_hSourceEvent;	//wait for source to notify this event
	double m_nLowerbound, m_nUpperbound;	//compare bound
	HANDLE m_threadSourceWaiting;	//in this thread, it waits for event notification
	THREADSTATUS m_statusSourceWaiting;	// the waiting thread status
	CONDTYPE m_condType;	// BIGGER, SMALLER, BETWEEN, BESIDE
	CAwareSource * m_pSource;	//the single event source to get the updated data from it

	char m_strEventTag[36];
};

typedef CCompareConditioner * CCompareConditionerPtr;