/*********************************************************
Compositional Event.
This is a kind of aware event that has two event sources,
called left hand side source and right hand side source, 
so that it is inherited from aware event. 
Compsitional event contains a boolean conditioner and two
event sources. the event sources could be simple events or
compositional events, but could not be aware sources.
The listener of the compositional event could be acutator 
or upper layer conditioner.
*********************************************************/
#pragma once
#include "awareevent.h"
#include "EventListener.h"

class CCompositionalEvent :
	public CAwareEvent
{
public:
	CCompositionalEvent(void);
public:
	~CCompositionalEvent(void);

public:
	virtual void SetSource(SOURCETYPE type, CEventSource * pSrc);
	virtual void SetConditioner(CEventConditioner * pCond);
	virtual void SetListener(HANDLE pEvent);
	virtual void Start();
	virtual void Stop();

public:
	CEventSource * m_lpSrc;
	CEventSource * m_rpSrc;
};
