/*********************************************************
Decision Engine Format.
This is the class formating output.
When the output is ready, it would notify the application
the format is a global variable, so that any class can 
output its result to the DCformat
*********************************************************/

#pragma once
#include <afxmt.h>
#include <Afxtempl.h>
#include <time.h>

typedef struct {
	char name[36];
	char value[255];
} FMItem;

typedef CArray<FMItem, FMItem&> FMItemArray;


static const char * szChangeEvent = "FormatValueHasBeenUpdated";

class __declspec( dllexport ) CDCFormat
{
public:
	CDCFormat(void);
public:
	~CDCFormat(void);

public:
	static void SetHWnd(CWnd *parent);
	static void OnReceive();
	static char * GetValue();//char * chValue);
	enum FORMATTYPE {FMAWARE=0, FMACTION};
	void Add(FORMATTYPE type, char *name, char *value);
	void FormatValue();

	static CCriticalSection m_dataLock;
	FMItemArray awareness;
	FMItem		action;
	time_t		m_tPrevtime;
};

extern CDCFormat * myGlobalFormat;
