// IniFile.h : main header file for the INIFILE DLL
//
/**************************************************
CInifile

Load and analyze configuration file
***************************************************/
#ifndef _INIFILE_H_
#define _INIFILE_H_

#include <stdio.h>

class __declspec(dllexport) CIniFile
{
public:
	CIniFile();
	CIniFile(char * pfilename);
	~CIniFile();
public:
	bool IniOpen(char *pfilename);
	bool IniClose();
	bool ReadIni(char * AreaName, char * ItemName, char * content);
	bool WriteIni(char * AreaName, char * ItemName, char * content);
protected:
	void ReadLine(char * line);
	bool IsArea(char * str);
	bool IsItem(char * str);
	void GetArea(char * line, char * str);
	void GetItemName(char * line, char * str);
	void GetItemContent(char * line, char * str);

	void InsertItem(char * content);
	void InsertNoItem(char * ItemName, char * content);
	void InsertEnd(char * ItemName, char * content);
	void InsertNoArea(char * AreaName, char * ItemName, char * content);
private:
	void check(bool b, char * msg);
	void stripWhite();
	FILE *m_pfile;
	bool m_bCloseFile;
};


#endif //INIFILE_H_
