/*****************************************************
directory service client
This class is the client side directory server. It is
used to communicate with directory server.
*****************************************************/

#ifndef _MODS_CLIENT_CLASS_HEADER_
#define _MODS_CLIENT_CLASS_HEADER_

#define MIDDLEWARE_OF_DIRECTORY_SERVICE

#include <afxmt.h>
#include <Winsock2.h>

class CModsClient
{
public:
	CModsClient();
	CModsClient(char * addr);
	virtual ~CModsClient();

public:
	void check(bool b, LPTSTR msg);
	virtual void ErrorReport(LPTSTR msg) {return;}

	enum SocketStatus {NONE=0, DISCONNECTED, CREATED, CONNECTED};
	enum ThreadStatus {CLOSED=0, CLOSING, RUNNING};

	void Start();
	void Close();
	VOID SendData(char *, int);
	VOID GetData(char *, int *);
	VOID SetServerAddr(char * addr);
	u_long GetLocalAddr();

protected:
	BOOL StartNetwork();
	BOOL CreateSocket();
	VOID CloseSocket();
	VOID CloseNetwork();

	BOOL StartTimers();
	VOID StopTimers();
	VOID TrapThread();
	static VOID CALLBACK TrapTimerProc(
		HWND hWnd, // handle of window for timer messages
		UINT uMsg,    // WM_TIMER message
		UINT idEvent, // timer identifier
		DWORD dwTime  // current system time
		);

	BOOL CreateThreads();
	VOID CloseThreads();
	BOOL CreateRecvThread();
	VOID CloseRecvThread();
	static DWORD WINAPI ThreadRecv(LPVOID arg);
	VOID RecvThread();
	virtual void OnReceive() {return;}

	VOID ProcBuf(char *, int);

private:
	SOCKET				m_sock;
	struct sockaddr_in	m_localAddr, m_modsServAddr, m_remoteAddr;
	SocketStatus		m_nSocketStatus;
	ThreadStatus		m_nRecvThdStatus;
	HANDLE				m_threadRecv;
	static CCriticalSection m_recvLock;

	static void *		pObject;
	UINT_PTR			pTrapTimer;

	char 				pStoreData[65535] ;
	int					nLenData;
	char				servAddr[20];
};

#endif //_MODS_CLIENT_CLASS_HEADER_