/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/*********************************************************
available bandwidth Awareness
inherited from network awareness.
Currently just load data from trace file
*********************************************************/
#pragma once

#define CONFIG_PARAM_PACKET_SIZE	"packetSize"
#define CONFIG_PARAM_PACKET_NUM		"packetNum"
#define CONFIG_PARAM_INTERVAL		"Interval"
#define APP_PARAM_REMOTE_ADDR		"RemoteAddress"

#define BANDWITH_CLIENT_PORT		5601
#define BANDWITH_SERVER_PORT		5602

#include <Afxsock.h>
#include "..\..\Source\component.h"
#include "..\..\Source\awaretool.h"

class DllExport CAvailableBW :
	public CAwareTool
{
public:
	CAvailableBW(void);
public:
	~CAvailableBW(void);

public:
	virtual bool SetConfParam(CWord key, CWord value);
	virtual bool SetAppParam(CWord key, void * value);
	virtual bool Start();
	virtual bool Stop();

protected:
	enum SOCKETSTATUS {DISCONNECTED=0, INITIALIZED, CREATED, CONNECTED};
	enum THREADSTATUS {CLOSED=0, CLOSING, RUNNING};

	bool	StartNetwork();
	bool	CreateSocket();
	bool	StartTimer();
	void	StopTimer();
	void	CloseSocket();
	void	CloseNetwork();

	static VOID CALLBACK MeasureBWProc(
		HWND hWnd, // handle of window for timer messages
		UINT uMsg,    // WM_TIMER message
		UINT idEvent, // timer identifier
		DWORD dwTime  // current system time
		);
	void	MeasureBWFun();

	BOOL CreateRecvThread();
	VOID CloseRecvThread();
	static DWORD WINAPI ThreadRecv(LPVOID arg);
	VOID RecvThread();

protected:
	SOCKETSTATUS status_socket;
	SOCKET		m_sock;
	sockaddr_in	m_localAddr, m_remoteAddr;
	bool		m_bAddrReady;

	UINT_PTR	m_pBWTimer;
	static void* pObject;
	char *		m_sendbuf;

	THREADSTATUS status_thread;
	HANDLE		m_threadRecv;
	LARGE_INTEGER	ticksPerSecond;

	int m_nPacketSize,	//Byte
		m_nPacketNum,
		m_nInterval;	//ms

};


DllExport CAvailableBW* GetThisComponent(void);