/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#include "AvailableCPU.h"
#include "..\..\Source\IniFile.h"

CAvailableCPU::CAvailableCPU(void) : CAwareTool()
{
	cid = CCMId("AvailableCPU", 1.0);

	m_threadSrcGenerator = NULL;
}

CAvailableCPU::~CAvailableCPU(void)
{
	Stop();
}

bool CAvailableCPU::SetConfParam(CWord key, CWord value)
{
	if (CONFIG_FILE_PARAM_FILE_DIR == key) {
		strcpy_s(s_filename, value.get());
	}
	else if (CONFIG_FILE_PARAM_FILE_AREA == key) {
		strcpy_s(s_dataarea, value.get());
	}
	else {
		return false;
	}
	return true;
}

bool CAvailableCPU::SetAppParam(CWord key, void * value)
{
	if (CONFIG_FILE_PARAM_FILE_DIR == key) {
	}
	else if (CONFIG_FILE_PARAM_FILE_AREA == key) {
	}
	else {
		return false;
	}
	return true;
}

bool CAvailableCPU::Start()
{
	if (!m_bStarted) {
		m_threadSrcGenerator = CreateThread(NULL, 0, ThreadGenerator, this, 0, NULL);
		m_bStarted = true;
	}
	return true; 
}

DWORD WINAPI CAvailableCPU::ThreadGenerator(LPVOID arg)
{
	CAvailableCPU * thisClass = (CAvailableCPU *)arg;
	thisClass->SourceGeneratorFun();
	thisClass->m_threadSrcGenerator = NULL;
	thisClass->m_bStarted = false;
	return 0;
}

void CAvailableCPU::SourceGeneratorFun()
{
	CIniFile inif;
	inif.IniOpen(s_filename);
	char strLen[20];
	inif.ReadIni(s_dataarea, CONFIG_FILE_LENGTH_NAME, strLen);
	int iLen = atoi(strLen);
	double * dtime	= new double[iLen];
	double * dvalue = new double[iLen];
	char strN[5], strItem[10], strValue[64];
	DWORD pPrevtime = 0;
	for (int i=0; i<iLen; i++) {
		_itoa_s(i+1, strN, 10);
		strcpy_s(strItem, CONFIG_FILE_TIME_PREFIX);
		strcat_s(strItem, strN);
		inif.ReadIni(s_dataarea, strItem, strValue);
		dtime[i] = atof(strValue);

		strcpy_s(strItem, CONFIG_FILE_VALUE_PREFIX);
		strcat_s(strItem, strN);
		inif.ReadIni(s_dataarea, strItem, strValue);
		dvalue[i] = atof(strValue);

		Sleep(DWORD(dtime[i]*1000) - pPrevtime);
		if (m_threadSrcGenerator == NULL) break;

		//set source data and notify conditioner
		SetValue(&(dvalue[i]), sizeof(dvalue[i]));
		NotifyConditioner();
		pPrevtime = DWORD(dtime[i]*1000);
	}
	delete[] dtime;
	delete[] dvalue;
	inif.IniClose();
}

bool CAvailableCPU::Stop()
{
	if (m_threadSrcGenerator != NULL && m_bStarted) {
//		TerminateThread(m_threadSrcGenerator,0);
		CloseHandle(m_threadSrcGenerator);
		m_threadSrcGenerator = NULL;
		m_bStarted = false;
	}
	return true;
}


CAvailableCPU * GetThisComponent(void)
{
	return new CAvailableCPU();
}