/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
// AwareDllTestDoc.cpp : implementation of the CAwareDllTestDoc class
//

#include "stdafx.h"
#include "AwareDllTest.h"

#include "AwareDllTestDoc.h"
#include "DlgConnectTo.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAwareDllTestDoc

IMPLEMENT_DYNCREATE(CAwareDllTestDoc, CDocument)

BEGIN_MESSAGE_MAP(CAwareDllTestDoc, CDocument)
	ON_COMMAND(ID_FILE_CONNECTTO, &CAwareDllTestDoc::OnFileConnectto)
	ON_COMMAND(ID_FILE_START, &CAwareDllTestDoc::OnFileStart)
	ON_COMMAND(ID_FILE_STOP, &CAwareDllTestDoc::OnFileStop)
	ON_COMMAND(ID_APP_EXIT, &CAwareDllTestDoc::OnAppExit)
	ON_COMMAND(ID_ADAPTATION_USEADAPTATION, &CAwareDllTestDoc::OnAdaptationUseadaptation)
	ON_UPDATE_COMMAND_UI(ID_FILE_CONNECTTO, &CAwareDllTestDoc::OnUpdateFileConnectto)
	ON_UPDATE_COMMAND_UI(ID_FILE_START, &CAwareDllTestDoc::OnUpdateFileStart)
	ON_UPDATE_COMMAND_UI(ID_FILE_STOP, &CAwareDllTestDoc::OnUpdateFileStop)
	ON_UPDATE_COMMAND_UI(ID_ADAPTATION_USEADAPTATION, &CAwareDllTestDoc::OnUpdateAdaptationUseadaptation)
END_MESSAGE_MAP()


// CAwareDllTestDoc construction/destruction

CAwareDllTestDoc::CAwareDllTestDoc()
{
	// TODO: add one-time construction code here
	pdcEngine		= NULL;
	m_pLocalView	= NULL;
	m_pRemoteView	= NULL;
	m_pbwServer		= NULL;
}

CAwareDllTestDoc::~CAwareDllTestDoc()
{
	m_pbwServer->Stop();
	delete m_pbwServer;

	ClearCompns();
}

BOOL CAwareDllTestDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	InitCompns();

	m_pbwServer = new CToolBWServer();
	m_pbwServer->Start();

	return TRUE;
}




// CAwareDllTestDoc serialization

void CAwareDllTestDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


// CAwareDllTestDoc diagnostics

#ifdef _DEBUG
void CAwareDllTestDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAwareDllTestDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CAwareDllTestDoc commands

void CAwareDllTestDoc::OnFileConnectto()
{
	// TODO: Add your command handler code here
	char dest[255];
	CDlgConnectTo dlgConn(m_pLocalView);
	if(dlgConn.DoModal()==IDOK) {
		dlgConn.m_strIPAddr += '\0';
		wcstombs_s(NULL, dest, 255, dlgConn.m_strIPAddr, dlgConn.m_strIPAddr.GetLength());
		pdcEngine->SyncTo(dest);

		pdcEngine->SetAppParam("AVAILABLEBW", "RemoteAddress", (void *)dest);
	}
}

void CAwareDllTestDoc::OnFileStart()
{
	// TODO: Add your command handler code here
//	pdcEngine->Start();
	m_pLocalView->SetTimer(1, 500, NULL);
}

void CAwareDllTestDoc::OnFileStop()
{
	// TODO: Add your command handler code here
	m_pLocalView->KillTimer(1);
	pdcEngine->Stop();
}

void CAwareDllTestDoc::OnAppExit()
{
	// TODO: Add your command handler code here
/*	RECT rect;
	CString str;
	m_pLocalView->GetClientRect(&rect);
	str.Format(_T("%d, %d"), rect.right-rect.left, rect.bottom-rect.top);
	AfxMessageBox(str);
	m_pRemoteView->GetClientRect(&rect);
	str.Format(_T("%d, %d"), rect.right-rect.left, rect.bottom-rect.top);
	AfxMessageBox(str);
*/
	AfxGetMainWnd()->SendMessage(WM_CLOSE);
}

void CAwareDllTestDoc::OnAdaptationUseadaptation()
{
	pdcEngine->SetAdaptation(!pdcEngine->m_bStarted);
}

void CAwareDllTestDoc::OnUpdateAdaptationUseadaptation(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(pdcEngine->m_bStarted);
}

void CAwareDllTestDoc::OnUpdateFileConnectto(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
}

void CAwareDllTestDoc::OnUpdateFileStart(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!pdcEngine->m_bStarted);
}

void CAwareDllTestDoc::OnUpdateFileStop(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(pdcEngine->m_bStarted);
}

void CAwareDllTestDoc::InitCompns()
{
	pdcEngine = new CDCEngine("dcRules.xml");//"dc.xml"; //dcSync.xml; //dcSyncReactv.xml
	pdcEngine->Initialize();

}

void CAwareDllTestDoc::InitParams()
{
	CMainFrame *pMainFrame	= (CMainFrame *)(AfxGetApp()->m_pMainWnd);
	m_pLocalView	= (CWnd *)(pMainFrame->GetIndividualView(0));
	m_pRemoteView	= (CWnd *)(pMainFrame->GetIndividualView(1));

	pdcEngine->SetHWnd(m_pLocalView);

	// Set the application parameters
	HWND hlocalwnd = m_pLocalView->GetSafeHwnd(),
		hRemotewnd = m_pRemoteView->GetSafeHwnd();
	RECT localRect, remoteRect;
	m_pLocalView->GetClientRect(&localRect);
	m_pRemoteView->GetClientRect(&remoteRect);

	int localwidth = localRect.right-localRect.left;
	int localheight= localRect.bottom-localRect.top;
	int remotewidth = remoteRect.right-remoteRect.left;
	int remoteheight= remoteRect.bottom-remoteRect.top;
	bool bAutoCapture = false;	// auto capture, do not need timer
	bool bLocalShow = false;	// send remote and show local
	bool bSaveMode	= false;	// send info header in every frame or just the first frame

	pdcEngine->SetAppParam("GRAB", GRAB_APP_PARA_MAINWND, (void *)&hlocalwnd);
	pdcEngine->SetAppParam("GRAB", GRAB_APP_PARA_DISPWIDTH, (void *)&localwidth);
	pdcEngine->SetAppParam("GRAB", GRAB_APP_PARA_DISPHEIGHT, (void *)&localheight);
	pdcEngine->SetAppParam("GRAB", GRAB_APP_PARA_AUTOCAPTURE, (void *)&bAutoCapture);
//	pdcEngine->SetAppParam("GRAB", GRAB_APP_PARA_SHOWLOCAL, (void *)&bLocalShow);
	pdcEngine->SetAppParam("GRAB", GRAB_APP_PARA_SAVEMODE, (void *)&bLocalShow);

	pdcEngine->SetAppParam("DISPLAY", DISP_APP_PARA_MAINWND, (void *)&hRemotewnd);
	pdcEngine->SetAppParam("DISPLAY", DISP_APP_PARA_DISPWIDTH, (void *)&remotewidth);
	pdcEngine->SetAppParam("DISPLAY", DISP_APP_PARA_DISPHEIGHT, (void *)&remoteheight);
}

void CAwareDllTestDoc::ClearCompns()
{
	if (pdcEngine != NULL) {
//		m_pLocalView->KillTimer(1);
		// stop the decision engine
		pdcEngine->Stop();
		// release the memory
		delete pdcEngine;
		pdcEngine = NULL;
	}
}
