/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
// AwareDllTestDoc.h : interface of the CAwareDllTestDoc class
//

#include "..\..\Source\DCEngine.h"
#include "..\..\Source\ToolBWServer.h"

#pragma once


class CAwareDllTestDoc : public CDocument
{
protected: // create from serialization only
	CAwareDllTestDoc();
	DECLARE_DYNCREATE(CAwareDllTestDoc)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Implementation
public:
	virtual ~CAwareDllTestDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	void InitCompns();
	void InitParams();
	void ClearCompns();

	CDCEngine	*pdcEngine;
	CWnd *m_pLocalView, *m_pRemoteView;
	CToolBWServer * m_pbwServer;

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFileConnectto();
public:
	afx_msg void OnBnClickedOk();
public:
	afx_msg void OnFileStart();
public:
	afx_msg void OnFileStop();
public:
	afx_msg void OnAppExit();
public:
	afx_msg void OnAdaptationUseadaptation();
public:
	afx_msg void OnUpdateFileConnectto(CCmdUI *pCmdUI);
public:
	afx_msg void OnUpdateFileStart(CCmdUI *pCmdUI);
public:
	afx_msg void OnUpdateFileStop(CCmdUI *pCmdUI);
public:
	afx_msg void OnUpdateAdaptationUseadaptation(CCmdUI *pCmdUI);
};
