/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
// LocalView.cpp : implementation file
//

#include "stdafx.h"
#include "AwareDllTest.h"
#include "LocalView.h"
#include "AwareDllTestDoc.h"
#include "MainFrm.h"

#include "..\..\Source\AwareMetaObject.h"

int gnArchChangeEventApp= RegisterWindowMessageA(szArchChangeEvent);


// CLocalView

IMPLEMENT_DYNCREATE(CLocalView, CView)

CLocalView::CLocalView()
{
	m_bShowed = false;
}

CLocalView::~CLocalView()
{
}

BEGIN_MESSAGE_MAP(CLocalView, CView)
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_REGISTERED_MESSAGE(gnArchChangeEventApp, OnReceiveArchChange)
END_MESSAGE_MAP()


// CLocalView drawing

void CLocalView::OnDraw(CDC* pDC)
{
	CAwareDllTestDoc* pDoc = (CAwareDllTestDoc*)GetDocument();
	// TODO: add draw code here
	GetParentFrame()->SetWindowText(_T("The Mobile Awareware Video Application"));
	if (!m_bShowed) {
		pDoc->InitParams();
		m_bShowed = true;
	}
}


// CLocalView diagnostics

#ifdef _DEBUG
void CLocalView::AssertValid() const
{
	CView::AssertValid();
}

#ifndef _WIN32_WCE
void CLocalView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif
#endif //_DEBUG


// CLocalView message handlers
void CLocalView::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	CAwareDllTestDoc * pDoc = (CAwareDllTestDoc *)GetDocument();

	if (nIDEvent == 1)
		pDoc->pdcEngine->StartMetaProcess();


	CView::OnTimer(nIDEvent);
}

void CLocalView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	CAwareDllTestDoc * pDoc = (CAwareDllTestDoc *)GetDocument();

	if (pDoc->pdcEngine != NULL) {
		pDoc->pdcEngine->SetAppParam("Grab", DISP_APP_PARA_DISPWIDTH, (void *)&cx);
		pDoc->pdcEngine->SetAppParam("Grab", DISP_APP_PARA_DISPHEIGHT, (void *)&cy);
	}
}

LRESULT CLocalView::OnReceiveArchChange(WPARAM wParam, LPARAM lPara)
{
	char buf[1024];
	CAwareDllTestDoc * pDoc = (CAwareDllTestDoc *)GetDocument();
	pDoc->pdcEngine->GetFormatValue(buf);

	SetStatusBar(buf);

	return 0;
}

void CLocalView::SetStatusBar(char * inf)
{
	CString str;
	str = inf;

	CMainFrame *pFrame=(CMainFrame *)AfxGetApp()->m_pMainWnd;
	CStatusBar* pStatus=&pFrame->m_wndStatusBar;

	if(pStatus){
//		pStatus->SetPaneInfo(2,0,SBPS_NORMAL,30);
		pStatus->SetPaneText(0,str);
	}
}