/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "..\..\Source\component.h"
#include "..\..\Source\awarelet.h"
#include "encoder/libr263.h"
#include "decoder/tmndec.h"


class DllExport CCompress :
	public CAwarelet
{
public:
	CCompress(void);
	bool SetConfParam(CWord key, CWord value);
	bool SetAppParam(CWord key, void * value);
	bool Start();
	bool Stop();

protected:
	int GetEncodeFormat(int width, int height);
	static void OwnWriteFunction(int byte);
	static BYTE m_cdata[MAX_BUFF_SIZE];
	static int  m_clen;

private:
	BITMAPINFO m_bmpInfo;
	CParam m_param;
	UINT yuv[MAX_BUFF_SIZE]; // this is a local virable, but we don't need to alloc mem so frequenctly
public:
	~CCompress(void);
private:
	int m_nCompressionRatio;
};

DllExport CCompress* GetThisComponent(void);