/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "..\..\Source\component.h"
#include "..\..\Source\awarelet.h"

#include <Vfw.h>
#include <afxmt.h>

class DllExport CGrab :
	public CAwarelet
{
public:
	CGrab(void);
	virtual bool SetConfParam(CWord key, CWord value);
	virtual bool SetAppParam(CWord key, void * value);
	virtual bool Start();
	virtual bool Stop();
public:
	~CGrab(void);
public:
	enum VIDEOSTATUS {NONE=0, INITIALIZED, DISCONNECTED, CONNECTED, STARTED};
	friend	LRESULT CALLBACK OnCaptureVideo(HWND hWnd, LPVIDEOHDR lpheader); 
	friend	LRESULT CALLBACK OnGrabFrame(HWND hWnd, LPVIDEOHDR lpheader); 
	friend	LRESULT CALLBACK StatusCallbackProc(HWND hWnd,int nID,LPSTR lpStatusText);
	friend	LRESULT CALLBACK ErrorCallbackProc(HWND hWnd,int nErrID,LPSTR lpErrorText);

public:
	static CCriticalSection m_hGrabLock;

public:
	bool InitializeVideo();
	bool ConnectVideo();
	bool capSetCaptureParam();
	bool capSetVideoParam();
	bool PreviewVideo();

	void SetAutoCapture(bool b=true);
	void SetLocalShow(bool b=true);
	void SetSaveMode(bool b=true);
	void SetVideoSource();
	void SetVideoFormat();
	void SetVideoDisplay();
	void ResizeGrabWnd(int cx, int y);

protected:
	void OnReceiveFrame(LPVIDEOHDR lpheader);
	void StretchToSupportedBmp(LPVIDEOHDR lpheader, LPBYTE lpOut);
private:
	int		nDispWidth, nDispHeight;
	bool	m_bAutoCapture, m_bLocalShow, m_bPrviewMode, m_bSaveMode;
	HWND	hMainWnd, hCapWnd;
	HANDLE	m_hEvent;
	VIDEOSTATUS	videoState;
	BITMAPINFO	m_bmpInfo, m_OldbmpInfo, m_StretchInfo;
	CAPDRIVERCAPS	m_gCapDriverCaps;
	CAPTUREPARMS m_OldcapParms;

};

DllExport CGrab* GetThisComponent(void);