/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/*********************************************************
AwareSource
This is a kind of event source, so that it is inherited from
CEventSource. The data of awaresource is from awareness tool
instead of awareevent.
*********************************************************/
#pragma once

#include "eventsource.h"
#include "awaretool.h"


class CAwareSource :
	public CEventSource
{
public:
	CAwareSource(void);

public:
	virtual ~CAwareSource(void);

public:
	CAwareSource::CAwareSource(CAwareSource &aware);
	CAwareSource& CAwareSource::operator =(CAwareSource &aware);
	bool CAwareSource::operator ==(CAwareSource &aware);
	bool CAwareSource::operator !=(CAwareSource &aware);


public:
	char * GetName();
	void SetName(char * name);
	void SetAwareTool(CAwareToolPtr p);
	void SetConfParam(CWord name, CWord value);
	void SetAppParam(CWord name, void * value);

	bool GetValue(void *, int *);
	void SetNotifier(HANDLE hNotifier);
	void Start();
	void Stop();

protected:
	char s_name[256];

protected:
	// aware tool notify the conditioner directly. instead of source notify the conditioner
	// just like conditioner notify the upper layer conditioner, instead of event.
	CAwareToolPtr m_pDataGenerator;
};

typedef CAwareSource * CAwareSrcPtr;
typedef CArray<CAwareSrcPtr, CAwareSrcPtr&> CAwareSrcPtrArray;