/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#pragma once

#include "common.h"
#include <Afxsock.h>

#define CM_CLIENT_PORT	5503

class CCMClient
{
public:
	CCMClient(void);
public:
	~CCMClient(void);

public:
	void SetRemoteAddr(char *, int);
	char * GetComponent(char *, float);

protected:
	enum SOCKETSTATUS {DISCONNECTED=0, INITIALIZED, CREATED, CONNECTED};

	bool	StartNetwork();
	bool	CreateSocket();
	void	CloseSocket();
	void	CloseNetwork();

private:
	SOCKETSTATUS status_socket;
	SOCKET		m_sock;
	sockaddr_in	m_localAddr, m_remoteAddr;
	
};

typedef CCMClient * CCMClientPtr;