/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/*********************************************************
Compare Conditioner
This is a kind of conditioner that compares "BIGGER","SMALLER",
"BETWEEN", or "BESIDES" operations, so that it is inherited 
from event conditioner. 
There is only one event source of compare conditioner.
the event sources of boolean conditioner must be awaresource,
instead of awareevent. so that the data is directly from
awareness measurement tools
*********************************************************/

#pragma once
#include "EventConditioner.h"
#include "AwareSource.h"

class CCompareConditioner :
	public CEventConditioner
{
public:
	CCompareConditioner(void);
	CCompareConditioner(char chTag);
public:
	~CCompareConditioner(void);

public:
	virtual void SetType(CONDTYPE type);
	virtual HANDLE GetCondtEvent(CEventSource::SOURCETYPE type);
	virtual void SetEventSource(CEventSource::SOURCETYPE type, CEventSource * pSrc);
	virtual bool GetCondtResult(bool bFormat = false);

	virtual void Start();
	virtual void Stop();

public:
	void SetLowerBound(double lb);
	void SetUpperBound(double ub);

	static DWORD WINAPI ThreadSrcWaiting(LPVOID arg);
	void SrcWaitingFun();
	void StartThread();
	void StopThread();

protected:
	HANDLE m_hSourceEvent;	//wait for source to notify this event
	double m_nLowerbound, m_nUpperbound;	//compare bound
	HANDLE m_threadSourceWaiting;	//in this thread, it waits for event notification
	THREADSTATUS m_statusSourceWaiting;	// the waiting thread status
	CONDTYPE m_condType;	// BIGGER, SMALLER, BETWEEN, BESIDE
	CAwareSource * m_pSource;	//the single event source to get the updated data from it

	char m_strEventTag[36];
};

typedef CCompareConditioner * CCompareConditionerPtr;