/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/********************************************************
CEvent Conditioner
This class descripe the conditioner in aware event. It is
the parent class of boolean conditioner and comapre conditioner.
boolean conditioner is used in the compositional event, 
and compare conditioner is used in the simple event.
********************************************************/

#pragma once

#include "EventSource.h"

#define MAX_VALUE_SIZE 1024

class CEventConditioner
{
public:
	CEventConditioner(void) { m_hListenerEvent= NULL; }
public:
	virtual ~CEventConditioner(void) { m_hListenerEvent= NULL; }

public:
	enum CONDTYPE {BIGGER=0, BETWEEN, BESIDE, SMALLER, AND, OR};
	enum THREADSTATUS {CLOSED=0, CLOSING, RUNNING};

	virtual void SetType(CONDTYPE type) {return;}
	virtual HANDLE GetCondtEvent(CEventSource::SOURCETYPE type) {return NULL;}
	virtual void SetEventSource(CEventSource::SOURCETYPE type, CEventSource * pSrc) {return;}
	virtual void Start() {return;}
	virtual void Stop() {return;}
	virtual bool GetCondtResult(bool bFormat = false) {return false;}

	void SetEventListener(HANDLE hLis) { m_hListenerEvent= hLis; }

protected:
	HANDLE	m_hListenerEvent;
};

typedef CEventConditioner * CEventConditionerPtr;