/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
// IniFile.h : main header file for the INIFILE DLL
//
#ifndef _INIFILE_H_
#define _INIFILE_H_

#include <stdio.h>

class __declspec(dllexport) CIniFile
{
public:
	CIniFile();
	CIniFile(char * pfilename);
	~CIniFile();
public:
	bool IniOpen(char *pfilename);
	bool IniClose();
	bool ReadIni(char * AreaName, char * ItemName, char * content);
protected:
	bool ReadLine(char * line);
	bool IsArea(char * str);
	bool GetArea(char * line, char * str);
	bool GetItem(char * line, char * str);
	bool GetContent(char * line, char * str);

	void Trim(char * str);
	void TrimLeft(char * str);
	void TrimRight(char * str);

private:
	void check(bool b, char * msg);
	void stripWhite();
	FILE *m_pfile;
	bool m_bCloseFile;
};


#endif //INIFILE_H_
