/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/*********************************************************
Simple Event.
This is a kind of aware event that has one event source,
which is a aware source that get the data from awareness
tools directly, and it is inherited from aware event. 
Compsitional event contains a compare conditioner and only
one source that is a aware source.
The listener of the compositional event could be acutator 
or upper layer conditioner.
*********************************************************/

#pragma once
#include "awareevent.h"

class CSimpleEvent :
	public CAwareEvent
{
public:
	CSimpleEvent(void);
public:
	~CSimpleEvent(void);

public:
	virtual void SetSource(SOURCETYPE type, CEventSource * pSrc);
	virtual void SetConditioner(CEventConditioner * pCond);
	virtual void SetListener(HANDLE pEvent);
	virtual void Start();
	virtual void Stop();

public:
	CEventSource * m_pSrc;
};
