/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#ifndef _MODS_DEFINATION_FILE_
#define _MODS_DEFINATION_FILE_

#define MODS_SERVER_PORT		61108
#define MODS_CLIENT_PORT		61117
#define MODS_TRAP_INTERVAL		10000	//ms
#define MODS_MAX_PACKET_SIZE	65535	//2^16-1 maximum number of an integer
#define THREAD_END_MAXWAIT		5
#define MODS_FIGHTER_LOST_TIME	30		//s

#define MODS_DEVICE_OID_LENGTH	2
#define MODS_VIDEO_OID_LENGTH	3
#define MODS_CHATBOX_OID_LENGTH	3
#define MODS_DISPLAY_OID_LENGTH	2
#define MODS_FIRE_OID_LENGTH	3
#define MODS_FIGHTER_OID_LENGTH	3
#define MODS_MESSAGE_OID_LENGTH	2
#define MODS_PATH_OID_LENGTH	3

#define	MODS_TYPE_NUMBER		3
#define DEVICE_TYPE_NUMBER		2
#define DISPLAY_TYPE_NUMBER		2
#define	MESSAGE_TYPE_NUMBER		1

#define MODS_ACCESS_READ_WRITE	102
#define MODS_ACCESS_READ_ONLY	103
#define MODS_ACCESS_NO_ACCESS	104

#define MODS_PROPERTY_NO_TRAP	112
#define MODS_PROPERTY_TRAP		113

#define MODS_INTEGER			101
#define MODS_STRING				102
#define	MODS_POSITION			103
#define MODS_FIRE				104
#define	MODS_FIREFIRGHTER		105
#define MODS_VIDEO				106
#define MODS_CHATBOX			107
#define MODS_NULL				109

/**********************************
#define FIRE_LEVEL1				101
#define FIRE_LEVEL2				102
#define FIRE_LEVEL3				103
#define FIRE_LEVEL4				104
#define FIRE_TYPE_NORMAL		111
#define FIRE_TYPE_CHEM			112
#define FIRE_TYPE_OIL			113
#define FIRE_TYPE_OTHER			114
#define NORMAL_FIRE_FIRGHTER	200
**********************************/

#define MODS_GET				101
#define	MODS_SET				102
#define MODS_EDIT				103
#define MODS_DELETE				104
#define MODS_GET_RESPONSE		111
#define MODS_TRAP				112
#define MODS_TRAP_REQUEST		113


//ptoi part
#define SELFPOS_UPDATE_INTERVAL	6000 //ms
#define BROADCAST_INTERVAL		1000 //ms
#define MAX_SIG_LOST_TIMES		3	 //ms
#define THREAD_TERMINATION_MAXWAIT 5
#define MAX_PACKET_BUFFER_SIZE	2048 //bytes

#define POSTOID_SOCKET_PORT		61024	//(10/24/06)
#define MODS_ONRECEIVE			1917

#endif //_MODS_DEFINATION_FILE_