/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
#include "AwareEvent.h"

CAwareEvent::CAwareEvent(void)
{
	m_pCondt = NULL;
	m_pListener = NULL;
}

CAwareEvent::~CAwareEvent(void)
{
	Stop();
	if (m_pCondt != NULL) {
		delete m_pCondt;
		m_pCondt = NULL;
	}

	if (m_pListener != NULL) {
		delete m_pListener;
		m_pListener = NULL;
	}
}

bool CAwareEvent::GetValue(char *value, int *len)
{
	bool bres = m_pCondt->GetCondtResult();
	if (bres) value[0] = '1';
	else value[0] = '0';
	value[1] = '\0';
	*len = sizeof(value);
	return true;
}

void CAwareEvent::SetNotifier(HANDLE hNotifier)
{
	m_pCondt->SetEventListener(hNotifier);
}
