/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/*********************************************************
AwareEvent
This is a virtual class that is the parent of SimpleEvent
and CompositionalEvent.
AwareEvent includes event source, event conditioner, and 
event listener, event source provides the data (from the 
awareness tool or from the lower layer event) to conditioner,
and the conditioner notify the listener if the condition
is sufficed. Upper compositional event or acutual would 
registers itself to the event as listener.
AwareEvent itself is also a subclass of EventSource, because
it is a eventsource of the upper layer compositional event.
*********************************************************/
#pragma once

#include "EventSource.h"
#include "EventConditioner.h"
#include "EventListener.h"

class CAwareEvent :
	public CEventSource
{
public:
	CAwareEvent(void);
public:
	virtual ~CAwareEvent(void);

public:
	virtual void SetSource(SOURCETYPE type, CEventSource * pSrc) {return;}
	virtual void SetConditioner(CEventConditioner * pCond) {return;}
	virtual void SetListener(HANDLE pEvent) {return;}

//inherited from source
public:
	virtual void Start() {return;}
	virtual void Stop()	 {return;}

	bool GetValue(char *value, int *len);
	void SetNotifier(HANDLE hNotifier);
protected:
	CEventConditioner * m_pCondt;
	CEventListener * m_pListener;
};

typedef CAwareEvent * CEventPtr;
typedef CArray<CEventPtr, CEventPtr&> CEventPtrArray;