/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
#include "AwareSource.h"
#include "component.h"

CAwareSource::CAwareSource(void)
{
	m_pDataGenerator = NULL;
}

CAwareSource::~CAwareSource(void)
{
	if (m_pDataGenerator != NULL) {
		FreeLibrary(m_pDataGenerator->GetDllInst());
		m_pDataGenerator = NULL;
	}
}

CAwareSource::CAwareSource(CAwareSource &aware)
{	
	strcpy_s(s_name, aware.s_name);
}

CAwareSource& CAwareSource::operator =(CAwareSource &aware)
{
	strcpy_s(s_name, aware.s_name);
	return *this;
}

bool CAwareSource::operator !=(CAwareSource &aware)
{
	if (strcmp(s_name, aware.s_name) == 0) 
		return false;
	else return true;
}

bool CAwareSource::operator ==(CAwareSource &aware)
{
	if (strcmp(s_name, aware.s_name) == 0) 
		return true;
	else return false;
}

void CAwareSource::SetName(char *name)
{
	strcpy_s(s_name, name);
}

char * CAwareSource::GetName()
{
	return s_name;
}

void CAwareSource::SetAwareTool(CAwareToolPtr p)
{
	m_pDataGenerator = p;
}


void CAwareSource::SetConfParam(CWord name, CWord value)
{
	m_pDataGenerator->SetConfParam(name, value);
}

void CAwareSource::SetAppParam(CWord name, void *value)
{
	m_pDataGenerator->SetAppParam(name, value);
}

void CAwareSource::SetNotifier(HANDLE hNotifier)
{
	m_pDataGenerator->AddNotifier(hNotifier);
}

void CAwareSource::Start()
{
	if (m_pDataGenerator != NULL && !m_pDataGenerator->IsStarted()) 
		m_pDataGenerator->Start();
}

void CAwareSource::Stop()
{
	if (m_pDataGenerator != NULL && m_pDataGenerator->IsStarted())
		m_pDataGenerator->Stop();
}

bool CAwareSource::GetValue(void * value, int * plen)
{
	return m_pDataGenerator->GetValue(value, plen);
}