/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#pragma once

#import "msxml4.dll"

#include "common.h"
#include "AwareMetaObject.h"
#include "SimpleEvent.h"
#include "CompositionalEvent.h"
#include "BooleanConditioner.h"
#include "CompareConditioner.h"
#include "CMClient.h"

class CAwareXMLParser
{
public:
	CAwareXMLParser();
	CAwareXMLParser(CWord, CMetaObjectPtr pObject = NULL);
	CAwareXMLParser(CMetaObjectPtr, CWord w = '\0');

	void SetXmlFile(CWord w);
	void SetMetaObject(CMetaObjectPtr);
	bool Parse();
public:
	~CAwareXMLParser(void);

protected:
	bool InitializeXML(char * xmlfile);
	void StartXMLParse(IXMLDOMNodePtr pNode);
	void ParseDirectoryServer(IXMLDOMNodePtr pDS);
	void ParseComponentManager(IXMLDOMNodePtr pCM);
	void ParseAwareTools(IXMLDOMNodePtr pAwares);
	void ParseAwarelets(IXMLDOMNodePtr pComps);
	void ParseRules(IXMLDOMNodePtr pRules);
	void ParseSingleRule(IXMLDOMNodePtr pRule);

protected:
	enum AWARELETTYPE {ACTIVE=0, REACTIVE, BOTH};
	CAwareToolPtr	CreateAwareTool(char *);
	CAwareletPtr	CreateAwarelet(char *);
	CAwareSrcPtr	GetSingleAwareTool(IXMLDOMNodePtr pAware);
	CRecfnCompntPtr	GetSingleAwarelet(IXMLDOMNodePtr pCompn, AWARELETTYPE &type);
	CEventPtr		GetCondition(IXMLDOMNodePtr pCond);
	CActuatorPtr 	GetActuator(IXMLDOMNodePtr pActs);
	CRecfnCompntPtr	GetSingleAct(IXMLDOMNodePtr pAct);

	static int		getChildrenNum(IXMLDOMNodePtr pNode);
	static void		dump_com_error(_com_error &e);
	static void		check(bool b, LPTSTR msg);

private:
	char					m_cEventTag;
	CWord					m_xmlFile;
	IXMLDOMElementPtr		m_pDocRoot;

	CMetaObjectPtr			m_pMetaObject;
	CCMClientPtr			m_pCMClient;
};

typedef CAwareXMLParser * CXMLParserPtr;
