/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/*********************************************************
Boolean Conditioner
This is a kind of conditioner that compares "AND" or "OR"
operations, so that it is inherited from event conditioner. 
There are two sources of boolean conditioner, called left 
source and right source. 
the event sources of boolean conditioner must be awareevent,
instead of awaresource. 
*********************************************************/
#pragma once
#include "EventConditioner.h"
#include "AwareEvent.h"

class CBooleanConditioner :
	public CEventConditioner
{
public:
	CBooleanConditioner(void);
	CBooleanConditioner(char chTag);
public:
	~CBooleanConditioner(void);

public:
	virtual void Start();
	virtual void Stop();
	virtual void SetType(CONDTYPE type);
	virtual HANDLE GetCondtEvent(CEventSource::SOURCETYPE type);
	virtual void SetEventSource(CEventSource::SOURCETYPE type, CEventSource * pSrc);
	virtual bool GetCondtResult(bool bFormat = false);

public:
	static DWORD WINAPI ThreadSrcWaiting(LPVOID arg);
	void SrcWaitingFun();
	void StartThread();
	void StopThread();

	bool getSourceData(CEventSource::SOURCETYPE side);

protected:
	HANDLE m_hSourceEvent[2];	//wait for sources to notify this event, left and right
	HANDLE m_threadSourceWaiting;	//in this thread, it waits for event notification
	THREADSTATUS m_statusSourceWaiting;	// the waiting thread status
	CONDTYPE m_condType;	// AND, OR
	CAwareEvent * m_pLeftSource;	//the event sources to get the updated data from it
	CAwareEvent * m_pRightSource;

	char m_strLEventTag[36], m_strREventTag[36];
};

typedef CBooleanConditioner * CBooleanConditionerPtr;