/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#pragma once

#define CM_SERVER_PORT	5501
#define THREAD_END_MAXWAIT	3

#include <Afxsock.h> // for socket

#include "btree.h"
#include "common.h"

class CCM
{
public:
	CCM(void);
	bool Start();
	bool Stop();
	bool IsStarted();
public:
	static void check(bool b, CString msg);
	~CCM(void);

protected:
	bool	CreateComponentTable();
	bool	StartWaitingThread();
	void	StopWaitingThread();
	void	ReleaseComponentTable();

private:
	enum THREADSTATUS {CLOSED=0, CLOSING, RUNNING};
	enum SOCKETSTATUS {DISCONNECTED=0, INITIALIZED, CREATED, CONNECTED};

	int		GetStringNum(char * content);
	void	GetStringList(char * content, int num, CString list[]);
	bool	GetCMId(char * fname, CCMId &id);

	bool	StartNetwork();
	bool	CreateSocket();
	static	DWORD WINAPI EventWaitingThread(LPVOID arg);
	void	EventWaitingFun();
	void	CloseNetwork();
	void	CloseSocket();

private:
	bool m_bIsStarted;
	BinTree<CCMId, char *> tb;
	
	THREADSTATUS status_thread;
	SOCKETSTATUS status_socket;

	SOCKET		m_sock;
	sockaddr_in	m_localAddr;
	HANDLE		m_threadWaiting;

};
