/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/********************************************************
Event Source
This class descripe the source in aware event. event source
provides data to conditioner. It is the parent class of 
aware source and event. 
event is the source used in the compositional event,
and aware source is used in the simple event.
********************************************************/

#pragma once

#define THREAD_TERMINATION_MAXWAIT 3

class CEventSource
{
public:
	CEventSource(void) {}
public:
	virtual ~CEventSource(void) {}

public:
	enum SOURCETYPE {LEFTSOURCE=0, RIGHTSOURCE, AWARESOURCE};
	enum THREADSTATUS {CLOSED=0, CLOSING, RUNNING};
	enum SOURCEDATATYPE {
		AWARE_INTEGER = 0,
		AWARE_DOUBLE,
		AWARE_BOOLEAN,
		AWARE_STRING
	};

public:
	virtual bool GetValue(char *value, int *len) {return false;}
	virtual void SetNotifier(HANDLE hNotifier) {return;}
	virtual void Start() {return;}
	virtual void Stop() {return;}
};

typedef CEventSource * CEventSourcePtr;
