/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
/*****************************************************
directory service client
This class is the client side directory server. It is
used to communicate with directory server.
*****************************************************/

#ifndef _MODS_CLIENT_CLASS_HEADER_
#define _MODS_CLIENT_CLASS_HEADER_

#define MIDDLEWARE_OF_DIRECTORY_SERVICE

#include <afxmt.h>
#include <Winsock2.h>

class CModsClient
{
public:
	CModsClient();
	CModsClient(char * addr);
	virtual ~CModsClient();

public:
	void check(bool b, LPTSTR msg);
	virtual void ErrorReport(LPTSTR msg) {return;}

	enum SocketStatus {NONE=0, DISCONNECTED, CREATED, CONNECTED};
	enum ThreadStatus {CLOSED=0, CLOSING, RUNNING};

	void Start();
	void Close();
	VOID SendData(char *, int);
	VOID GetData(char *, int *);
	VOID SetServerAddr(char * addr);
	u_long GetLocalAddr();

protected:
	BOOL StartNetwork();
	BOOL CreateSocket();
	VOID CloseSocket();
	VOID CloseNetwork();

	BOOL StartTimers();
	VOID StopTimers();
	VOID TrapThread();
	static VOID CALLBACK TrapTimerProc(
		HWND hWnd, // handle of window for timer messages
		UINT uMsg,    // WM_TIMER message
		UINT idEvent, // timer identifier
		DWORD dwTime  // current system time
		);

	BOOL CreateThreads();
	VOID CloseThreads();
	BOOL CreateRecvThread();
	VOID CloseRecvThread();
	static DWORD WINAPI ThreadRecv(LPVOID arg);
	VOID RecvThread();
	virtual void OnReceive() {return;}

	VOID ProcBuf(char *, int);

private:
	SOCKET				m_sock;
	struct sockaddr_in	m_localAddr, m_modsServAddr, m_remoteAddr;
	SocketStatus		m_nSocketStatus;
	ThreadStatus		m_nRecvThdStatus;
	HANDLE				m_threadRecv;
	static CCriticalSection m_recvLock;

	static void *		pObject;
	UINT_PTR			pTrapTimer;

	char 				pStoreData[65535] ;
	int					nLenData;
	char				servAddr[20];
};

#endif //_MODS_CLIENT_CLASS_HEADER_