/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"

#include "ReconfigComponent.h"

CReconfigComponent::CReconfigComponent()
{
	m_pCompnt = NULL;
	m_pParamArray.RemoveAll();
}

CReconfigComponent::~CReconfigComponent()
{
	m_pParamArray.RemoveAll();
}

CReconfigComponent & CReconfigComponent::operator = (const CReconfigComponent &w)
{
	if(this != &w){
		m_pParamArray.RemoveAll();
		m_pCompnt = w.m_pCompnt;
		for (INT_PTR i = 0; i < w.m_pParamArray.GetSize(); i++) {
			COMPNTPARAM param = w.m_pParamArray[i];
			m_pParamArray.Add(param);
		}
	}
	return *this;
}

void CReconfigComponent::SetComponent(CAwareletPtr pComp) {
	m_pCompnt = pComp;
}

CAwareletPtr CReconfigComponent::GetComponent()
{
	return m_pCompnt;
}

void CReconfigComponent::SetName(CWord w)
{
	s_name = w;
}

CWord CReconfigComponent::GetName()
{
	return s_name;
}

void CReconfigComponent::AddParam(CWord key, CWord value)
{
	COMPNTPARAM tParam;
	tParam.key = key;
	tParam.value = value;
	m_pParamArray.Add(tParam);
}

void CReconfigComponent::SetParam(CWord key, CWord value)
{
	INT_PTR i;
	for (i = 0; i < m_pParamArray.GetSize(); i++) {
		if (m_pParamArray[i].key == key) m_pParamArray[i].value = value;
		break;
	}
	if (i == m_pParamArray.GetSize()) AddParam(key, value);
}

