/**
 * Copyright (c) 2005 - Lehigh University. Bethlehem, PA, USA.
 * All rights reserved.
 * This source code is a part of MARCHES Project. 
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs, and the author attribution appear in all copies of this
 * software.
 *
 * IN NO EVENT SHALL LEHIGH UNIVERSITY BE LIABLE TO ANY PARTY FOR DIRECT, 
 * INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LEHIGH
 * UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *	
 * LEHIGH UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, 
 * AND LEHIGH UNIVERSITY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, 
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 **/


////////////////////////////////////////////////////////////////////////////////
#include "StdAfx.h"
#include "SimpleEvent.h"

CSimpleEvent::CSimpleEvent(void)
{
	m_pSrc = NULL;
	m_pCondt = NULL;
	m_pListener = NULL;
}

CSimpleEvent::~CSimpleEvent(void)
{
	if (m_pSrc != NULL) {
		// can not delete the awareness here because it is just a pointer
		// delete m_pSrc; deleted by metaobject
		m_pSrc = NULL;
	}

	if (m_pCondt != NULL) {
		delete m_pCondt;
		m_pCondt = NULL;
	}

	if (m_pListener != NULL) {
		delete m_pListener;
		m_pListener = NULL;
	}
}

void CSimpleEvent::SetSource(SOURCETYPE type, CEventSource *pSrc)
{
	m_pSrc = pSrc;
	if (m_pCondt != NULL) {
		m_pSrc->SetNotifier(m_pCondt->GetCondtEvent(CEventSource::AWARESOURCE));
		m_pCondt->SetEventSource(CEventSource::AWARESOURCE, m_pSrc);
	}			
}

void CSimpleEvent::SetConditioner(CEventConditioner * pCond)
{
	m_pCondt = pCond;
	if (m_pCondt != NULL) {
		m_pSrc->SetNotifier(m_pCondt->GetCondtEvent(CEventSource::AWARESOURCE));
		m_pCondt->SetEventSource(CEventSource::AWARESOURCE, m_pSrc);
	}			
}

void CSimpleEvent::SetListener(HANDLE pEvent)
{
	m_pListener = NULL; //maybe layer we need to listener
	SetNotifier(pEvent);
}

void CSimpleEvent::Start()
{
//	m_pListener->Start();
	m_pCondt->Start();
	m_pSrc->Start();
}

void CSimpleEvent::Stop()
{
	m_pSrc->Stop();
	m_pCondt->Stop();
//	m_pListener->Stop();
}
